Drag and drop

Bootstrap 5 Drag and drop plugin

Drag and Drop plugin built with Bootstrap 5. Examples of draggable list, cards, tables, grid, buttons. Available sort, copy, scroll, disable, delay, nested & other options.

Note: Read the API tab to find all available options and advanced customization

Try out MDB Drag & Drop Builder

Note: Currently, the plugin is only compatible with the basic MDB package imported in UMD format. More about import MDB formats.


Draggable basic example

Make an element draggable by adding the data-mdb-draggable-init attribute to the element with the class .draggable-element.

        
            
        <div class="draggable-element shadow-3" data-mdb-draggable-init>
          <p>Drag me!</p>
        </div>
      
        
    

Custom container

Disable the x-axis or y-axis by adding the data-mdb-block-x-axis or data-mdb-block-y-axis attribute, respectively.

        
            
        <div class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-container="#draggable-container">
          <p>Drag me!</p>
        </div>
      
        
    

Blocked axis

Thanks to data-mdb-block-x-axis attribute or data-mdb-block-y-axis attribute you can disable x or y axis.

        
            
        <div class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-block-x-axis="true" data-mdb-container="#draggable-container-2">
          <p>Drag me!</p>
        </div>

        <div class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-block-y-axis="true" data-mdb-container="#draggable-container-2">
          <p>Drag me!</p>
        </div>
      
        
    

Delay

Set the delay for starting dragging by adding the data-mdb-delay attribute with a value in milliseconds.

Drag me after one second!

        
            
        <div class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-delay="1000">
          <p>Drag me after one second!</p>
        </div>
      
        
    

Disabled

You can set your draggable element as disabled by adding data-mdb-disabled with true value.

        
            
        <div class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-disabled="true">
          <p>Disabled</p>
        </div>
      
        
    

Custom drag button

By adding data-mdb-drag-handle with selector you can set drag handler of your element. Note that drag handler has to be inside an element.

Drag only on button!

        
            
        <div class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-drag-handle=".draggable-drag-ico">
          <i class="fas fa-arrows-alt draggable-drag-ico"></i>
          <p>Drag only on button!</p>
        </div>
      
        
    

Scrolling option

When your draggable element is inside a scrollable container, the container will scroll when you approach its edge.

        
            
        <div id="draggable-scroll" class="draggable-element shadow-1-strong" data-mdb-draggable-init data-mdb-container="#draggable-container-6">
          <p>Drag!</p>
        </div>
      
        
    

Sortable basic example

Make your list sortable by adding the data-mdb-sortable attribute with a value of sortable. Note that only elements with the data-mdb-sortable-init attribute will be able to be sorted.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
        <div data-mdb-sortable-init class="sortable-list">
          <div class="sortable-item">Item 1</div>
          <div class="sortable-item">Item 2</div>
          <div class="sortable-item">Item 3</div>
          <div class="sortable-item">Item 4</div>
          <div class="sortable-item">Item 5</div>
        </div>
      
        
    

Horizontal example

A sortable list will work with any element configuration or direction, as it is not limited to a vertical layout.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
        <div data-mdb-sortable-init class="sortable-list d-flex">
          <div class="sortable-item">Item 1</div>
          <div class="sortable-item">Item 2</div>
          <div class="sortable-item">Item 3</div>
          <div class="sortable-item">Item 4</div>
          <div class="sortable-item">Item 5</div>
        </div>
      
        
    

Grid example

Sortable can also be implemented with the grid layout.

Item 1
Item 2
Item 3
Item 4
Item 5
Item 6
Item 7
Item 8
Item 9
Item 10
Item 11
Item 12
        
            
        <div id="sortable-grid" data-mdb-sortable-init class="sortable-list d-flex flex-wrap">
          <div class="sortable-item">Item 1</div>
          <div class="sortable-item">Item 2</div>
          <div class="sortable-item">Item 3</div>
          <div class="sortable-item">Item 4</div>
          <div class="sortable-item">Item 5</div>
          <div class="sortable-item">Item 6</div>
          <div class="sortable-item">Item 7</div>
          <div class="sortable-item">Item 8</div>
          <div class="sortable-item">Item 9</div>
          <div class="sortable-item">Item 10</div>
          <div class="sortable-item">Item 11</div>
          <div class="sortable-item">Item 12</div>
        </div>
      
        
    
        
            
        #sortable-grid .sortable-item {
          width: 125px;
          height: 125px;
          margin: 15px;
          display: flex;
          justify-content: center;
          border: 1px solid var(--mdb-secondary-border-subtle);
          background: var(--mdb-secondary-bg-subtle);
          text-align: center;
        }
      
        
    

Multiple tables

Connect your list with others by adding the data-mdb-connected-list attribute. Note that you need to set the value as a selector when initializing your component via data attributes.

To do

Item 1
Item 2
Item 3
Item 4
Item 5
Disabled

Done

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <div id="sortable-multi-tables-1" data-mdb-sortable-init class="sortable-list" data-mdb-connected-list="#sortable-multi-tables-2">
              <h4 class="text-center pt-2">To do</h4>
              <div class="sortable-item">Item 1</div>
              <div class="sortable-item">Item 2</div>
              <div class="sortable-item">Item 3</div>
              <div class="sortable-item">Item 4</div>
              <div class="sortable-item">Item 5</div>
              <div class="sortable-item" data-mdb-disabled="true">Disabled</div>
            </div>

            <div id="sortable-multi-tables-2" data-mdb-sortable-init class="sortable-list" data-mdb-connected-list="#sortable-multi-tables-1">
              <h4 class="text-center pt-2">Done</h4>
              <div class="sortable-item">Item 6</div>
              <div class="sortable-item">Item 7</div>
              <div class="sortable-item">Item 8</div>
              <div class="sortable-item">Item 9</div>
              <div class="sortable-item">Item 10</div>
            </div>
          
        
    

Coping items

By adding data-mdb-copy with value true you can copy your items to connected table.

Elements

Item 1
Item 2
Item 3
Item 4
Item 5

Copy

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
        <div
          id="sortable-copy-1"
          class="sortable-list"
          data-mdb-connected-list="#sortable-copy-2"
          data-mdb-copy="true"
          data-mdb-sorting="false"
          data-mdb-sortable-init
        >
          <h4 class="text-center pt-2">Elements</h4>
          <div class="sortable-item">Item 1</div>
          <div class="sortable-item">Item 2</div>
          <div class="sortable-item">Item 3</div>
          <div class="sortable-item">Item 4</div>
          <div class="sortable-item">Item 5</div>
        </div>

        <div
          id="sortable-copy-2"
          class="sortable-list"
          data-mdb-connected-list="#sortable-copy-1"
          data-mdb-sortable-init
        >
          <h4 class="text-center pt-2">Copy</h4>
          <div class="sortable-item">Item 6</div>
          <div class="sortable-item">Item 7</div>
          <div class="sortable-item">Item 8</div>
          <div class="sortable-item">Item 9</div>
          <div class="sortable-item">Item 10</div>
        </div>
      
        
    

Conditions

Customize the conditions for permitting the sending or copying of items to a connected table by adding your custom function that return true or false to the enterPredicate property. It's important to note that you can only initialize this via JavaScript.

Numbers

1
2
3
4
5

Only odd numbers

7
        
            
        <div id="sortable-condition-1" class="sortable-list" data-mdb-sortable-init>
          <h4 class="text-center pt-2">Numbers</h4>
          <div class="sortable-item" data-mdb-value="1">1</div>
          <div class="sortable-item" data-mdb-value="2">2</div>
          <div class="sortable-item" data-mdb-value="3">3</div>
          <div class="sortable-item" data-mdb-value="4">4</div>
          <div class="sortable-item" data-mdb-value="5">5</div>
        </div>

        <div id="sortable-condition-2" class="sortable-list" data-mdb-sortable-init>
          <h4 class="text-center pt-2">Only odd numbers</h4>
          <div class="sortable-item" data-mdb-value="7">7</div>
        </div>
      
        
    
        
            
        // Your custom function with true/false return
        const accessOddNumbers = (value) => {
          return parseInt(value) % 2;
        }

        const sortableCondition1 = document.getElementById('sortable-condition-1');
        const sortableCondition2 = document.getElementById('sortable-condition-2');

        const instanceSortableCondition1 = new DragAndDrop.Sortable(sortableCondition1, {
          connectedList: sortableCondition2,
          enterPredicate: accessOddNumbers,
        });
        const instanceSortableCondition2 = new DragAndDrop.Sortable(sortableCondition2);
      
        
    

Disabled sorting

To disable sorting in a table, add the data-mdb-sorting attribute with a value of false.

Sorting available

Item 1
Item 2
Item 3
Item 4
Item 5

Sorting not available

item 6
item 7
        
            
            <div id="sortable-disabled-1" data-mdb-sortable-init class="sortable-list"
              data-mdb-connected-list="#sortable-disabled-2">
              <h4 class="text-center pt-2">Sorting available</h4>
              <div class="sortable-item">Item 1</div>
              <div class="sortable-item">Item 2</div>
              <div class="sortable-item">Item 3</div>
              <div class="sortable-item">Item 4</div>
              <div class="sortable-item">Item 5</div>
            </div>

            <div id="sortable-disabled-2" data-mdb-sortable-init class="sortable-list"
              data-mdb-connected-list="#sortable-disabled-1" data-mdb-sorting="false">
              <h4 class="text-center pt-2">Sorting not available</h4>
              <div class="sortable-item">item 6</div>
              <div class="sortable-item">item 7</div>
            </div>
          
        
    

Nested

By adding data-mdb-item-class you can set what class has to be in your list item to make them sortable. Thanks to that you can make nested lists.

To do

Item 1
Item 2
Item 3
Item 4
Item 5

Done

item 6
item 7
item 8
item 9
        
            
          <div id="sortable-multi-1-1" data-mdb-sortable-init class="sortable-list d-flex align-items-start" data-mdb-item-class="sortable-item-nested">
            <div id="sortable-multi-2-2" data-mdb-sortable-init class="sortable-item-nested" data-mdb-connected-list="#sortable-multi-2-1" data-mdb-drag-handle=".drag-handler">
              <h4 class="text-center pt-2 drag-handler">To do</h4>
              <div class="sortable-item">Item 1</div>
              <div class="sortable-item">Item 2</div>
              <div class="sortable-item">Item 3</div>
              <div class="sortable-item">Item 4</div>
              <div class="sortable-item">Item 5</div>
            </div>

            <div id="sortable-multi-2-1" data-mdb-sortable-init class="sortable-item-nested" data-mdb-connected-list="#sortable-multi-2-2" data-mdb-drag-handle=".drag-handler">
              <h4 class="text-center pt-2 drag-handler">Done</h4>
              <div class="sortable-item">item 6</div>
              <div class="sortable-item">item 7</div>
              <div class="sortable-item">item 8</div>
              <div class="sortable-item">item 9</div>
            </div>
          </div>
        
        
    

Drag and drop - API


Import

        
            
          import { Draggable, Sortable } from 'mdb-drag-and-drop';
        
        
    
        
            
          @import '~mdb-drag-and-drop/css/drag-and-drop.min.css';
        
        
    

Usage

Via data attributes

Using the Drag And Drop plugin doesn't require any additional JavaScript code - simply add data-mdb-draggable-init attribute to .draggable-element and data-mdb-sortable-init attribute to sortable-list and use other data attributes to set all options.

        
            
      <!-- Draggable -->
      <div class="draggable-element" data-mdb-draggable-init></div>

      <!-- Sortable -->
      <div data-mdb-sortable="sortable" data-mdb-sortable-init>
        <div class="sortable-item">Item 1</div>
        <div class="sortable-item">Item 2</div>
        <div class="sortable-item">Item 3</div>
        <div class="sortable-item">Item 4</div>
        <div class="sortable-item">Item 5</div>
      </div>
    
        
    

Via JavaScript

        
            
      // Draggable
      const draggableEl = document.getElementById('draggable');
      const instanceDraggable = new DragAndDrop.Draggable(draggableEl, {
        ...options,
      });

      // Sortable
      const sortableEl = document.getElementById('sortable');
      const instanceSortable = new DragAndDrop.Sortable(sortableEl, {
        ...options
      });
    
        
    

Via jQuery

Note: By default, MDB does not include jQuery and you have to add it to the project on your own.

        
            
        $(document).ready(() => { 
          // Draggable
          $('#draggable').Draggable();

          // Sortable
          $('#sortable').Sortable();
        });
          
        
    

Options

Options can be passed via data attributes or JavaScript. For data attributes, append the option name to data-mdb-, as in data-mdb-delay="".

Draggable

Name Type Default Description
blockXAxis Boolean false Defines whether 'x' axis is blocked or not
blockYAxis Boolean false Defines whether 'y' axis is blocked or not
container String body Defines container of dragging element
delay Number 0 Defines how long will deley exist before element starts to drag
disabled Boolean false Defines whether element is able to drag or not
disabled Boolean false Defines whether element is able to drag or not
dragHandle String '' Defines drag handler of the element. Note, handler has to be inside of the dragging element
draggingClass String dragging Defines class which is using during dragging of the element
scrollPixels Number 40 If container is scrollable, defines distance from edges where scrolling will begin

Sortable

Name Type Default Description
animationDuration Number 300 Defines duration of sliding and returning animations
connectedList Element / Null / String' null Defines list which you want to connect with
copy Boolean false Defines whether you want to copy elements from one list to another or send them instead
enterPredicate Function () => true Defines function which check access between tables
itemClass String sortable-item Defines class name for sortable items.
sorting Boolean true Defines whether list is able to sort or not

Methods

Draggable

dispose - Removes draggable instance. instanceDraggable.dispose()
resetPosition - Return original position of the element. instanceDraggable.resetPosition()
getInstance element Static method which allows you to get the draggable instance associated to a DOM element. Draggable.getInstance(draggableElement)
        
            
                      const draggableElement = document.getElementById('draggable');
                      const instanceDraggable = DragAndDrop.Draggable.getInstance(draggableElement);
                      instanceDraggable.resetPosition();
                    
        
    

Sortable

dispose - Removes sortable instance. instanceSortable.dispose()
addItem element, index Adds element to the sortable list. You can set position in the list of your new item by adding index number. Note: If you did not insert an index number, your element would append at the end of the list. instanceSortable.addItem(el, 2)
getInstance element Static method which allows you to get the sortable instance associated to a DOM element. Sortable.getInstance(sortableElement)
removeItem id Removes element from the sortable list. You pass element id as an argument. instanceSortable.removeItem(id)
        
            
                      const newElement = document.createElement('div');
                      newElement.classList.add('sortable-item');
                      newElement.textContent = 'New Element';

                      const sortableElement = document.getElementById('sortable');
                      const instanceSortable = DragAndDrop.Sortable.getInstance(sortableElement);
                      instanceSortable.addItem(newElement);

                      instanceSortable.removeItem("exampleId");
                    
        
    

Events

Draggable

Name Description
start.mdb.draggable Emitted when an element is started dragging.
end.mdb.draggable Emitted when an element is ended dragging.
itemMove.mdb.draggable Emitted when an element is dragging.
        
            
                      const draggableItem = document.getElementById('dragging');
                      draggableItem.addEventListener('start.mdb.draggable', () => {
                        alert('Start dragging');
                      });
                      
        
    

Sortable

Name Description
itemMove.mdb.sortable Emitted when one of the items from list changed its position.
listChange.mdb.sortable Emitted when one of the items from list will enter to connected table.
        
            
                      const sortableItem = document.getElementById('sortable-item-1');
                      sortableItem.addEventListener('itemMove.mdb.sortable', (e) => {
                        alert(e.target);
                      });

Drag and drop

Angular Bootstrap 5 Drag and drop plugin

Drag and Drop plugin built with Bootstrap 5. Examples of draggable list, cards, tables, grid, buttons. Available sort, copy, scroll, disable, delay, nested & other options.

Note: Read the API tab to find all available options and advanced customization


Draggable basic example

By adding mdbDraggable directive you can make your custom element draggable.

Drag me!

        
            
            <div mdbDraggable class="draggable shadow-1-strong">
              <p>Drag me!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Custom container

If you want to have your draggable component in a container, just add boundaryElement directive with selector to your component.

Drag me!

        
            
            <section
              #draggableContainer
              class="border p-4 mb-4"
              style="height: 400px; overflow: hidden;"
            >
              <div mdbDraggable class="draggable shadow-1-strong" [boundaryElement]="draggableContainer">
                <p>Drag me!</p>
              </div>
            </section>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Blocked axis

Thanks to [lockAxis] input you can disable x or y axis.

Drag me!

Drag me!

        
            
            <div mdbDraggable class="draggable shadow-1-strong" [lockAxis]="'x'">
              <p>Drag me!</p>
            </div>
            <div mdbDraggable class="draggable shadow-1-strong" [lockAxis]="'y'">
              <p>Drag me!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Delay

You can set deley of starting dragging by adding [delay] input with miliseconds value.

Drag me after one second!

        
            
            <div mdbDraggable [delay]="1000" class="draggable shadow-1-strong">
              <p>Drag me after one second!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Disabled

You can set your draggable element as disabled by adding [disabled] with true value.

Disabled

        
            
            <div mdbDraggable [disabled]="true" class="draggable shadow-1-strong">
              <p>Disabled</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Custom drag button

By adding [handle] input with element or element selector you can set drag handler of your element. Note that drag handler has to be inside an element.

Drag only on button!

        
            
            <div mdbDraggable [handle]="handle" class="draggable shadow-1-strong">
              <i #handle class="fas fa-arrows-alt draggable-drag-ico"></i>
              <p>Drag only on button!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
              position: relative;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }

            .draggable-drag-ico {
              position: absolute;
              top: 10px;
              right: 10px;
              font-size: 1.5rem;
              color: grey;
            }
          
        
    

Scrolling option

When your draggable element is inside a scrollable container your component will scroll its while you will be near the edge.

        
            
            <div mdbDraggable [autoScroll]="true" class="draggable shadow-1-strong">
              <p>Drag!</p>
            </div>
          
        
    
        
            
            .draggable {
              display: flex;
              width: 200px;
              height: 200px;
              justify-content: center;
              align-items: center;
              background-color: white;
              position: relative;
            }

            .draggable-dragging {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }

            .draggable-drag-ico {
              position: absolute;
              top: 10px;
              right: 10px;
              font-size: 1.5rem;
              color: grey;
            }
          
        
    

Sortable basic example

By adding mdbSortableContainer directive you can add sortable functionality to the items in a container. Note, only elements with mdbDraggable directive name will be able to sort.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            <div mdbSortableContainer class="sortable-list" (itemDrop)="onDrop($event)">
              <div mdbDraggable *ngFor="let item of items" class="sortable-item">{{ item.name }}</div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' }
              ];

              onDrop(event: MdbDropEvent) {
                moveItemsInContainer(this.items, event.previousIndex, event.newIndex);
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Horizontal example

Sortable list will create no matter how rotated it is.

Item 1
Item 2
Item 3
Item 4
Item 5
        
            
            <div mdbSortableContainer class="sortable-list d-flex" (itemDrop)="onDrop($event)">
              <div mdbDraggable *ngFor="let item of items" class="sortable-item">{{ item.name }}</div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' }
              ];

              onDrop(event: MdbDropEvent) {
                moveItemsInContainer(this.items, event.previousIndex, event.newIndex);
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              width: 100%;
              border-bottom: none;
              border-left: 1px solid #ccc;
              border-right: 1px solid #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Grid example

Sortable list works with grid as well.

Item 1
Item 2
Item 3
Item 4
Item 5
Item 6
Item 7
Item 8
Item 9
Item 10
Item 11
Item 12
        
            
            <div mdbSortableContainer class="sortable-list d-flex flex-wrap" (itemDrop)="onDrop($event)">
              <div mdbDraggable *ngFor="let item of items" class="sortable-item">{{ item.name }}</div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' },
                { name: 'Item 6' },
                { name: 'Item 7' },
                { name: 'Item 8' },
                { name: 'Item 9' },
                { name: 'Item 10' },
                { name: 'Item 11' },
                { name: 'Item 12' },
              ];

              onDrop(event: MdbDropEvent) {
                moveItemsInContainer(this.items, event.previousIndex, event.newIndex);
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              justify-content: center;
              align-items: center;
              width: 125px;
              height: 125px;
              margin: 15px;
              border: 1px solid #ccc;
              text-align: center;
              user-select: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Multiple tables

By using [containers] input you can connect your list with other container.

To do

Item 1
Item 2
Item 3
Item 4
Item 5
Disabled

Done

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">To do</h4>
                <div mdbDraggable [disabled]="item.disabled" *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Done</h4>
                <div mdbDraggable [disabled]="item.disabled" *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1', disabled: false },
                { name: 'Item 2', disabled: false },
                { name: 'Item 3', disabled: false },
                { name: 'Item 4', disabled: false },
                { name: 'Item 5', disabled: false },
                { name: 'Disabled', disabled: true }
              ];

              itemsSecond = [
                { name: 'Item 6', disabled: false },
                { name: 'Item 7', disabled: false },
                { name: 'Item 8', disabled: false },
                { name: 'Item 9', disabled: false },
                { name: 'Item 10', disabled: false }
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Coping items

By adding [copy] input with value true you can copy your items to connected table.

Elements

Item 1
Item 2
Item 3
Item 4
Item 5

Copy

Item 6
Item 7
Item 8
Item 9
Item 10
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Elements</h4>
                <div mdbDraggable [copy]="item.copy" *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Copy</h4>
                <div mdbDraggable *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, copyItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1', copy: true },
                { name: 'Item 2', copy: true },
                { name: 'Item 3', copy: true },
                { name: 'Item 4', copy: true },
                { name: 'Item 5', copy: true },
              ];

              itemsSecond = [
                { name: 'Item 6' },
                { name: 'Item 7' },
                { name: 'Item 8' },
                { name: 'Item 9' },
                { name: 'Item 10' },
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  copyItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Conditions

You can set your own conditions about permission to sending or coping items to connected table by adding your custom function with true / false return to [enterPredicate] input.

Numbers

1
2
3
4
5

Only odd numbers

7
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Numbers</h4>
                <div mdbDraggable [data]="item.data" *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" [enterPredicate]="enterPredicate" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Only odd numbers</h4>
                <div mdbDraggable [data]="item.data" *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent, MdbDraggableDirective } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1', data: '1' },
                { name: 'Item 2', data: '2' },
                { name: 'Item 3', data: '3' },
                { name: 'Item 4', data: '4' },
                { name: 'Item 5', data: '5' },
              ];

              itemsSecond = [
                { name: 'Item 7', data: '7' },
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }

              enterPredicate(item: MdbDraggableDirective) {
                return item.data % 2 !== 0;
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Disabled sorting

By setting sorting input to false you can disable sorting in table.

Sorting available

Item 1
Item 2
Item 3
Item 4
Item 5

Sorting not available

item 6
item 7
        
            
            <div class="d-flex">
              <div #firstContainer="mdbSortableContainer" mdbSortableContainer [containers]="[secondContainer]" [data]="itemsFirst" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Sorting available</h4>
                <div mdbDraggable *ngFor="let item of itemsFirst" class="sortable-item">{{ item.name }}</div>
              </div>
              <div #secondContainer="mdbSortableContainer" mdbSortableContainer [containers]="[firstContainer]" [data]="itemsSecond" [sortingDisabled]="true" class="sortable-list" (itemDrop)="onDrop($event)">
                <h4 class="text-center pt-2">Sorting disabled</h4>
                <div mdbDraggable *ngFor="let item of itemsSecond" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              itemsFirst = [
                { name: 'Item 1' },
                { name: 'Item 2' },
                { name: 'Item 3' },
                { name: 'Item 4' },
                { name: 'Item 5' },
              ];

              itemsSecond = [
                { name: 'Item 6' },
                { name: 'Item 7' },
              ];

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Nested

To do

Item 1
Item 2
Item 3
Item 4
Item 5

Done

item 6
item 7
item 8
item 9
        
            
            <div
              id="sortable-multi-1-1"
              class="sortable-list d-flex align-items-start"
              mdbSortableContainer
              [data]="nestedContainers"
              (itemDrop)="onDrop($event)"
            >
              <div
                *ngFor="let container of nestedContainers"
                class="sortable-list sortable-item-nested"
                mdbSortableContainer
                [id]="container.id"
                [data]="container.data"
                [containers]="getConnectedContainers(container.id)"
                mdbDraggable
                (itemDrop)="onDrop($event)"
              >
                <h4 class="text-center pt-2 drag-handler">{{ container.name }}</h4>
                <div mdbDraggable *ngFor="let item of container.data" class="sortable-item">{{ item.name }}</div>
              </div>
            </div>
          
        
    
        
            
            import { Component } from '@angular/core';
            import { moveItemsInContainer, moveItemToNewContainer, MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              nestedContainers = [
                {
                  id: 'nested-sortable-1',
                  name: 'To do',
                  data: [
                    { name: 'Item 1' },
                    { name: 'Item 2' },
                    { name: 'Item 3' },
                    { name: 'Item 4' },
                    { name: 'Item 5' },
                  ],
                },
                {
                  id: 'nested-sortable-2',
                  name: 'Done',
                  data: [{ name: 'Item 6' }, { name: 'Item 7' }, { name: 'Item 8' }, { name: 'Item 9' }],
                },
              ];

              getConnectedContainers(id: string) {
                return this.nestedContainers.filter((container) => container.id !== id).map((container) => container.id);
              }

              onDrop(event: MdbDropEvent) {
                if (event.previousContainer === event.newContainer) {
                  moveItemsInContainer(event.newContainer.data, event.previousIndex, event.newIndex);
                } else {
                  moveItemToNewContainer(
                    event.previousContainer.data,
                    event.newContainer.data,
                    event.previousIndex,
                    event.newIndex
                  );
                }
              }
            };
          
        
    
        
            
            .sortable-list {
              width: 500px;
              max-width: 100%;
              border: solid 1px #ccc;
              min-height: 60px;
              display: block;
              background: #fff;
              border-radius: 4px;
            }

            .sortable-item {
              padding: 20px 10px;
              border-bottom: solid 1px #ccc;
              color: rgba(0, 0, 0, 0.87);
              background: #fff;
              display: flex;
              flex-direction: row;
              align-items: center;
              justify-content: space-between;
              user-select: none;
            }

            .sortable-item:last-child {
              border: none;
            }

            .draggable-helper {
              box-shadow: 0 5px 15px 0 rgba(0, 0, 0, 0.21) !important;
            }
          
        
    

Drag and drop - API


Installation

To install and configure the plugin follow our Plugins Installation Guide. Please remember to update all the plugin names and import paths. You can find all the necessary information in the Import section.

        
            
     npm i git+https://oauth2:ACCESS_TOKEN@git.mdbootstrap.com/mdb/angular/mdb5/plugins/prd/drag-and-drop
     
        
    

Import

        
            
          import { MdbDragAndDropModule } from 'mdb-angular-drag-and-drop';
          …
          @NgModule ({
            ...
            imports: [MdbDragAndDropModule],
            ...
          })
        
        
    
        
            
        @import 'mdb-angular-drag-and-drop/scss/drag-and-drop.scss';
      
        
    

Inputs

MdbDraggableDirective

Name Type Default Description
boundaryElement HTMLElement | String body Defines boundary container for dragged element
copy Boolean false Defines if dragged element should be moved or copied to new container
data any - Defines draggable element data
delay Number 0 Defines how long will deley exist before element starts to drag
disabled Boolean false Defines whether element is able to drag or not
handle HTMLElement | String - Defines drag handler of the element. Note, handler has to be inside of the dragging element
lockAxis 'x' | 'y' | null null Defines whether 'x' or 'y' axis is blocked

MdbSortableContainerDirective

Name Type Default Description
containers MdbSortableContainer | String [] Defines list of connected containers
enterPredicate Function () => true Defines function which check access between tables
sortingDisabled Boolean false Defines whether list is able to sort or not

Outputs

MdbDraggableDirective

Name Type Description
dragStart EventEmitter<HTMLElement> Emitted on drag start.
dragEnd EventEmitter<HTMLElement> Emitted on drag end.
        
            
            <section class="border p-4 d-flex justify-content-center mb-4" style="height: 400px">
              <div
                mdbDraggable
                (dragStart)="onDragStart($event)"
                class="draggable-element shadow-1-strong"
              >
                <p>Drag me!</p>
              </div>
            </section>                                      
            
        
    
        
            
            import { Component } from '@angular/core';
            
            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              onDragStart(target: HTMLElement) {
                console.log('drag started:', target);
              }
            }                                       
            
        
    

MdbSortableContainerDirective

Name Type Description
itemDrop EventEmitter<MdbDropEvent> Emitted on element drop in container
        
            
            <section class="border p-4 d-flex justify-content-center mb-4">
              <div mdbSortableContainer class="sortable-list" (itemDrop)="onDrop($event)">
                <div mdbDraggable class="sortable-item" *ngFor="let item of items">
                  {{ item.name }}
                </div>
              </div>
            </section>                                    
            
        
    
        
            
            import { Component } from '@angular/core';
            import { MdbDropEvent } from 'mdb-angular-drag-and-drop';

            @Component({
              selector: 'app-root',
              templateUrl: './app.component.html',
            })
            export class AppComponent {
              items = [
              { name: 'Item 1' },
              { name: 'Item 2' },
              { name: 'Item 3' },
              { name: 'Item 4' },
              { name: 'Item 5' },
            ];

            onDrop(event: MdbDropEvent) {
              console.log('item dropped', event)
            }
            }                                       
            
        
    

Advanced types

MdbDropEvent

        
            
            interface MdbDropEvent {
              item: MdbDraggableDirective;
              previousContainer: MdbSortableContainerDirective;
              newContainer: MdbSortableContainerDirective;
              previousIndex: number;
              newIndex: number;
            }

Draggable

Vue Bootstrap Draggable

Note: This documentation is for an older version of Bootstrap (v.4). A newer version is available for Bootstrap 5. We recommend migrating to the latest version of our product - Material Design for Bootstrap 5.
Go to docs v.5

MDB Vue Draggable plugin provides a custom directive which allows moving objects by clicking on them and dragging them anywhere within the container.

To start working with the Draggable plugin, see the - "API" tab on this page.


Basic example

        
            
            <template>
              <div class="drag-container">
                <div v-mdb-draggable class="dragged-element green"></div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
            </style>
          
        
    

Auto-scroll

Adding .scroll modifier enables auto-scrolling when element its move beyond a scroll container boundaries. In the directive's value, specify the scroll speed and scroll container's ID (if this value is undefined the directive will use the parent's parentNode ).

        
            
            <template>
              <div class="drag-container" id="scroll-container">
                <div :style="{ height: '900px', width: '120vw' }">
                  <div
                    v-mdb-draggable.scroll="{ scroll: { containerId: 'scroll-container', speed: 10 } }"
                    class="dragged-element green"
                  ></div>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                max-height: 400px;
                overflow: scroll;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
            </style>
          
        
    

Axis

Use .x and .y modifiers to enable dragging to only one axis.

X

Y

        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable.x
                  :style="{ top: '200px', left: 'calc(100% - 120px)' }"
                  class="dragged-element grey"
                >
                  <p>X</p>
                </div>
                <div v-mdb-draggable.y class="dragged-element green">
                  <p>Y</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Cursor style

By default, the cursor style is set to crosshair - you can change that by adding the cursor option in the directive's value.

Move

Pointer

        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{ cursor: 'move' }"
                  :style="{ top: '200px', left: 'calc(100% - 120px)' }"
                  class="dragged-element grey"
                >
                  <p>Move</p>
                </div>
                <div
                  v-mdb-draggable="{ cursor: 'pointer' }"
                  class="dragged-element green"
                >
                  <p>Pointer</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Handles

You can enable dragging only when the cursor is over a specific part of your element, by binding it's ID to the handle key in the directive's value object.

        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{ handle: 'drag-handle' }"
                  :style="{ top: '100px', left: '10px' }"
                  class="dragged-element grey"
                >
                  <div
                    id="drag-handle"
                    :style="{ borderRadius: '50%', width: '40%', height: '40%' }"
                    class="green"
                  ></div>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Events

You can specify custom callbacks for start, drag and end events. Additionally, the drag callback is called with two arguments - top and left values of the dragged element.

  • @start: 0
  • @drag: 0
  • @end 0
        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{
                    start: handleStart,
                    drag: handleDrag,
                    end: handleEnd
                  }"
                  class="dragged-element green"
                >
                  <ul>
                    <li>
                      @start: {{count.start}}
                    </li>
                    <li>
                      @drag: {{count.drag}}
                    </li>
                    <li>
                      @end: {{count.end}}
                    </li>
                  </ul>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                },
                data() {
                  return {
                    count: {
                      start: 0,
                      drag: 0,
                      end: 0
                    }
                  };
                },
                methods: {
                  handleStart() {
                    this.count.start++;
                  },
                  handleDrag() {
                    this.count.drag++;
                  },
                  handleEnd() {
                    this.count.end++;
                  }
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .dragged-element ul {
                padding: 0;
                list-style: none;
              }
              .dragged-element ul li {
                margin: 5px 0;
                padding: 5px 0;
                border-bottom: 1px solid rgba(0, 0, 0, 0.3);
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Snap to the container (inner mode)

Add the snap options to the directive's value in order to enable snapping to other elements/container. There are three options available:

  • tolerance (Number) - required
  • mode (String) - required, two values acceptable: inner and outer
  • referenceId (String, Array) - id of the reference element/elements - if not specified, the directive will use the parent.
        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{ snap: { tolerance: 80, mode: 'inner' } }"
                  class="dragged-element green"
                ></div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Snap to the other elements (outer mode)

        
            
            <template>
              <div class="drag-container">
                <div
                  id="el-1"
                  v-mdb-draggable="{
                    snap: { referenceId: ['el-2'], tolerance: 30, mode: 'outer' }
                  }"
                  class="dragged-element green"
                ></div>
                <div
                  id="el-2"
                  v-mdb-draggable="{
                    snap: {
                      referenceId: 'el-1',
                      tolerance: 30,
                      mode: 'outer'
                    }
                  }"
                  class="dragged-element grey"
                  :style="{ top: '250px' }"
                ></div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Revert position

To return the dragged object to its original position after dragging has ended, use the .revert modifier.

Element will return to its initial position

        
            
            <template>
              <div class="drag-container">
                <div v-mdb-draggable.revert class="dragged-element green">
                  <p>Element will return to its initial position</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
            </style>
          
        
    

Offset

You can customize offset from each container's edge, by adding offset object to the directive's value. The offset object:

  • top - offset from the top edge in px (Number, default: 0)
  • bottom - offset from the bottom edge in px (Number, default: 0)
  • left - offset from the left edge in px (Number, default: 0)
  • right - offset from the right edge in px (Number, default: 0)
        
            
            <template>
              <div class="drag-container">
                <div
                  v-mdb-draggable="{
                    offset: { top: 10, bottom: 30, left: 10, right: 60 }
                  }"
                  :style="{ left: 'calc(50% - 60px', top: '10px' }"
                  class="dragged-element green"
                >
                  <p>Try moving the element towards the container's edges</p>
                </div>
              </div>
            </template>
          
        
    
        
            
            <script>
              import { mdbDraggable } from "mdb-draggable";
              export default {
                directives: {
                  mdbDraggable
                }
              };
            </script>
          
        
    
        
            
            <style>
              .drag-container {
                width: 100%;
                height: 500px;
                border-radius: 5px;
                box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
                -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
              }
              .dragged-element {
                width: 100px;
                height: 100px;
                border-radius: 5px;
                font-size: 12px;
                padding: 10px;
                display: flex;
                align-items: center;
                justify-content: center;
                user-select: none;
                text-align: center;
                transition: all 0.4s linear;
                transition-property: background-color;
              }
              .green {
                background-color: rgba(76, 175, 80, 0.3);
              }
              .grey {
                background-color: rgba(96, 125, 139, 0.3);
              }
            </style>
          
        
    

Vue Draggable - getting started : download & setup


Download

This plugin requires a purchase.

Buy Draggable plugin

Modifiers

Name Description Example
.scroll Enables auto scroll <div v-mdb-draggable.scroll="{ scroll: { containerId: '..', speed: '..'}}" ></div>
.x Disables dragging along Y axis <div v-mdb-draggable.x ></div>
.y Disables dragging along X axis <div v-mdb-draggable.y ></div>
.revert Reverts the element to its original position after dragging has ended <div v-mdb-draggable.revert ></div>

Value - keys

Name Type Description Example
scroll Object Two options available: speed (Number) and containerId (String) <div v-mdb-draggable="{ scroll: { speed: 10, containerId: '..'}}" ></div>
snap Object Three options available: mode (String: 'outer' / 'inner'), referenceId (String, Array) and tolerance (Number) <div v-mdb-draggable="{ snap: { tolerance: 10, referenceId: '..', mode: 'inner'}}" ></div>
offset Object You can specify an offset in pixels (Number) from all container's edges. <div v-mdb-draggable="{ offset: { top: 10, left: 10, bottom: 30, right: 16 }}" ></div>
handle String The id of the drag-handle. <div v-mdb-draggable="{ handle: 'handle-id' }" ></div>
cursor String The cursor's style <div v-mdb-draggable="{ cursor: 'pointer' }" ></div>
parentId String The parent container's id - if not specified, the directive will use the parentNode. <div v-mdb-draggable="{ parentId: '...' }" ></div>
start Function The callback for the start event <div v-mdb-draggable="{ start: onStart }" ></div>
drag Function The callback for the drag event which will be called with two arguments: top and left values. <div v-mdb-draggable="{ drag: onDrag }" ></div>
end Function The callback for the end event <div v-mdb-draggable="{ end: onEnd }" ></div>

Example

        
            
    <template>
      <div class="drag-container" id="parent">
        <div id="el-1" v-mdb-draggable.revert.x.scroll="options" class="dragged-element green">
          <div class="handle grey" id="handle"></div>
        </div>
      </div>
    </template>
    
        
    
        
            
    <script>
      import {
        mdbDraggable
      } from "mdb-draggable";

      export default {
        directives: {
          mdbDraggable
        },
        data() {
          return {
            options: {
              scroll: {
                speed: 10,
                containerId: "../"
              },
              snap: {
                tolerance: 50,
                referenceId: "...",
                mode: "outer"
              },
              offset: {
                top: 10,
                left: 10,
                right: 70,
                bottom: 100
              },
              handle: "handle",
              parentId: "parent",
              cursor: "pointer",
              drag: () => {},
              start: () => {},
              end: () => {}
            }
          };
        }
      };
    </script>
    
        
    
        
            
    <style>
      .drag-container {
        width: 100%;
        height: 500px;
        border-radius: 5px;
        box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
        -webkit-box-shadow: 0 10px 20px 0 rgba(0, 0, 0, 0.09);
      }

      .dragged-element {
        width: 100px;
        height: 100px;
        border-radius: 5px;
        font-size: 12px;
        padding: 10px;
        display: flex;
        align-items: center;
        justify-content: center;
        user-select: none;
        text-align: center;
        transition: all 0.4s linear;
        transition-property: background-color;
      }

      .handle {
        width: 30px;
        height: 30px;
        border-radius: 50%;
      }

      .green {
        background-color: rgba(76, 175, 80, 0.3);
      }

      .grey {
        background-color: rgba(96, 125, 139, 0.3);
      }
    </style>